package WD::Counter;

use strict;
use warnings;
use WD::Counter::Memcached;
use DBI;

our $COUNTER_KEY = 'counter';

sub new {
    my $class = shift;
    my $dbi = DBI->connect('DBI:mysql:database=counter','root','') or die 'connection failed';
    bless {
          db        => $dbi,
          memcached => WD::Counter::Memcached->new,
          @_,
    }, $class;
}

sub counter_key { $COUNTER_KEY }

sub incr_memcached {
    my $self = shift;
    $self->{memcached}->incr( $self->counter_key );
}

sub counter {
    my $self = shift;

    my $count = $self->incr_memcached;

    if ( !$count ) {
       $count = $self->{db}->selectrow_arrayref( 'select counter from counter')->[0];
       $self->{memcached}->add( $self->counter_key, $count , 24*60*60);
    }

    if ( $count % 100 ) {
        $self->{db}->do( 'update counter set counter=?',{} ,$count );
    }

    $count;
}

1;
