#include <stdio.h>
#include <stdlib.h>

#include "apr_general.h"
#include "apr_pools.h"
#include "apr_memcache.h"

int main(int argc, char **argv)
{
    apr_status_t rv;
    apr_pool_t *p;
    apr_memcache_t *memc;
    apr_memcache_server_t *ms;
    char *value;
    apr_size_t value_len;
    apr_uint16_t flags;

    if(argc < 3) {
        fprintf(stderr, "Usage: %s <key> <value>\n", argv[0]);
        return 0;
    }

    apr_initialize();
    apr_pool_create(&p, NULL);
    rv = apr_memcache_create(p, 10, 0, &memc);
    rv = apr_memcache_server_create(p, "127.0.0.1", 11211,
                                    0, 0, 0, 0, &ms);
    if(rv != APR_SUCCESS) {
        fprintf(stderr, "could not connect to server.");
        return -1;
    }
    apr_memcache_add_server(memc, ms);
    rv = apr_memcache_set(memc, argv[1], argv[2],
                          strlen(argv[2]), 0, 0);
    if(rv != APR_SUCCESS){
        fprintf(stderr, "set error");
        return -1;
    }
    rv = apr_memcache_getp(memc, p, argv[1],
                           &value, &value_len, &flags);
    if(rv != APR_SUCCESS) {
        fprintf(stderr, "get error");
        return -1;
    }

    printf("%s\n", value);

    apr_pool_destroy(p);
    apr_terminate();

    return 0;

}
