#include <stdio.h>
#include <string.h>

#include "libmemcached/memcached.h"

int main(int argc, char **argv)
{
    struct memcached_st *memc;
    struct memcached_server_st *servers;
    memcached_return rc;
    char *val;
    size_t val_len;
    uint32_t flags;

    if(argc < 3) {
        fprintf(stderr, "Usage: %s <key> <value>\n", argv[0]);
        return 0;
    }
    memc = memcached_create(NULL);
    servers = memcached_servers_parse("127.0.0.1:11211");
    rc = memcached_server_push(memc, servers);
    if(rc != MEMCACHED_SUCCESS) {
        fprintf(stderr, "Error: %s\n", memcached_strerror(memc, rc));
        return -1;
    }
    rc = memcached_set(memc, argv[1], strlen(argv[1]),
                       argv[2], strlen(argv[2]), 0, 0);
    if(rc != MEMCACHED_SUCCESS) {
        fprintf(stderr, "Error: %s\n", memcached_strerror(memc, rc));
        return -1;
    }

    val = memcached_get(memc, argv[1], strlen(argv[1]),
                        &val_len, &flags, &rc);
    if(rc == MEMCACHED_SUCCESS) {
        printf("%s => %s\n", argv[1], val);
    }
    if(val)
        free(val);

    memcached_server_list_free(servers);
    memcached_free(memc);
}
